#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
    int T,N,M,S;
    cin>>T;
    for(int i=0;i<T;i++){
        cin>>N>>M>>S;
        unordered_set<int> ros;
        for(int j=0;j<S;j++){
            int te;
            cin>>te;
            ros.insert(te);
        }
        unordered_map<int,int> m;
        vector<pair<int,int>> ans;
        for(int j=0;j<M;j++){
            int a,b;
            cin>>a>>b;
            if((m[a]==0||m[b]==0)&&(!ros.count(a)||m[a]==0)&&(!ros.count(b)||m[b]==0)){
                m[a]++;
                m[b]++;
                ans.push_back({a,b});
            }
        }
        if(ans.size()==N-1){
        cout<<N-1<<"\n";
        for(const auto& pars:ans){
            cout<<pars.first<<" "<<pars.second<<"\n";
        }
        }else cout<<-1<<"\n";
    }
}